/*
 *
 *    Copyright (c) 1999 Grant Erickson <grant@lcse.umn.edu>
 *
 *    Copyright 2000 MontaVista Software Inc.
 *	PPC405 modifications
 * 	Author: MontaVista Software, Inc.
 *         	frank_rowand@mvista.com or source@mvista.com
 * 	   	debbie_chu@mvista.com
 *
 *    Copyright 2001 Vitesse Semiconductor Corp.
 *      Based on walnut.h.
 *
 *    Module name: jetway.h
 *    (Why does this say "ppc405.h" in walnut.h)
 *
 *    Description:
 *      Macros, definitions, and data structures specific to the IBM PowerPC
 *      based boards.
 *
 *      This includes:
 *
 *         VITESSE "Jetway" board.
 *
 */

#ifdef __KERNEL__
#ifndef	__JETWAY_H__
#define	__JETWAY_H__

/* We have a 405GP core */
#include <platforms/ibm405gp.h>

#ifndef __ASSEMBLY__

/* bd_t structure */
#include <asm/ppcboot.h>
#define bi_tbfreq bi_intfreq

#ifdef __cplusplus
extern "C" {
#endif

#define BASE_BAUD		691200
	
/* Memory map for the VITESSE "Genie" 405GP generic CPU board and 405GPr Refboard.
 * Generic 4xx.
 */

#define VITGEN_CPLD_SIZE            ((uint)32*1024*1024) /* VitGenIO driver assumes the same size as VITGEN_CS2367_TARGET_SIZE. */
#define VITGEN_FPGA_SIZE            ((uint)32*1024*1024) /* VitGenIO driver assumes the same size as VITGEN_CS2367_TARGET_SIZE. */
#define VITGEN_CS2_EXT_FLASH_SIZE   ((uint)16*1024*1024) /* Extended FLASH on 405GPr Refboard */

#define VITGEN_CS2367_TARGET_BS     5 /* 0: 1MB, 1: 2MB, 2: 4MB, 3: 8MB, 4: 16MB, 5: 32MB, 6: 64MB, 7: 128MB (max) */
#define VITGEN_CS2367_TARGET_SIZE   ((uint)(1<<VITGEN_CS2367_TARGET_BS)*1024*1024)

#define VITGEN_CPLD_ADDR            ((uint)0x10000000) /* VITGEN_CS5_TARGET_ADDR */
#define VITGEN_FPGA_ADDR            ((uint)0x18000000) /* VITGEN_CS4_TARGET_ADDR */
#define VITGEN_CS2_TARGET_ADDR      ((uint)0x50000000) /* Only on Genie, not on 405GPr Refboard */
#define VITGEN_CS2_EXT_FLASH_ADDR   ((uint)0x21000000) /* Extended FLASH on 405GPr Refboard */
#define VITGEN_CS3_TARGET_ADDR      ((uint)0x58000000)
#define VITGEN_CS6_TARGET_ADDR      ((uint)0x48000000)
#define VITGEN_CS7_TARGET_ADDR      ((uint)0x40000000)

/* Aliases: */
#define VITGEN_CS4_TARGET_ADDR      VITGEN_FPGA_ADDR
#define VITGEN_CS5_TARGET_ADDR      VITGEN_CPLD_ADDR
#define VITGEN_FPGA32BIT_ADDR       VITGEN_FPGA_ADDR
#define VITGEN_FPGA32BIT_SIZE       VITGEN_FPGA_SIZE


extern char pci_irq_table[][4];

#ifdef __cplusplus
}
#endif

#endif /* __ASSEMBLY__ */

#define PPC4xx_MACHINE_NAME	"Vitesse Jetway"

#endif /* __JETWAY_H__ */
#endif /* __KERNEL__ */


