
/*
 * platforms/mv_pmc8245.h
 * 
 * Definitions for Marvell MV_PMC8245 Test Platform
 *
 * Author: Aharon Gadot aharong@radlan.com
 *
 * Copyright 2004 Radlan a Marvell Company Ltd.
 *
 * This program is free software; you can redistribute  it and/or modify it
 * under  the terms of  the GNU General Public License as published by the
 * Free Software Foundation;  either version 2 of the  License, or (at your
 * option) any later version.
 */

#ifndef __PPC_PLATFORMS_MV_PMC8245_H
#define __PPC_PLATFORMS_MV_PMC8245_H

#define BOARD_VENDOR	"Marvell"
#define BOARD_MACHINE	"MV_PMC8245"


#define MV_PMC8245_PCI_IRQ              0
#define MV_PMC8245_RTC_IRQ              1
#define MV_PMC8245_UART_IRQ             2
#define MV_PMC8245_ETHERNET_IRQ         3
#define MV_PMC8245_EXTERNAL_INT_IRQ     4

#define MV_PMC8245_NUM_OF_IRQS          5
#define MV_PMC8245_FIRST_IRQ            0

#define ETHERNET_1_IDSEL     16
#define ETHERNET_2_IDSEL     18

#define CPLD_RESET           0xFF010000
#define CPLD_LED             0xFF010001
#define CPLD_INT_MASK        0xFF010002
#define CPLD_INT_STATUS      0xFF010003
#define CPLD_INT_CAUSE       0xFF010004

#define MV_PMC8245_TODC_BASE 0xFF040000
#define MV_PMC8245_TODC_SIZE 0x100       /* 256 bytes for TODC */

#define MV_PMC8245_NVRAM_EXT_RAM_ADRS   0x10
#define MV_PMC8245_NVRAM_EXT_RAM_DATA   0x13
#define MV_PMC8245_NVRAM_CONTROLB       0xF

#define CPLD_RESET_VAL       0x00000000

#endif /* __PPC_PLATFORMS_MV_PMC8245_H */

