/*
 * On-Chip Peripheral definitions for BCM47xx.
 *
 * Copyright (c) 2003	LVL7 Systems, Inc.
 * John W. Linville <linville@lvl7.com>
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

/* Memory controller register offsets */
#define	MEMCTRL_CONTROL		0x00
#define	MEMCTRL_CONFIG		0x04
#define	MEMCTRL_REFRESH		0x08
#define	MEMCTRL_BISTSTAT	0x0c
#define	MEMCTRL_MODEBUF		0x10
#define	MEMCTRL_BKCLS		0x14
#define	MEMCTRL_PRIORINV	0x18
#define	MEMCTRL_DRAMTIM		0x1c
#define	MEMCTRL_INTSTAT		0x20
#define	MEMCTRL_INTMASK		0x24
#define	MEMCTRL_INTINFO		0x28
#define	MEMCTRL_NCDLCTL		0x30
#define	MEMCTRL_RDNCDLCOR	0x34
#define	MEMCTRL_WRNCDLCOR	0x38
#define	MEMCTRL_MISCDLYCTL	0x3c
#define	MEMCTRL_DQSGATENCDL	0x40
#define	MEMCTRL_SPARE		0x44
#define	MEMCTRL_TPADDR		0x48
#define	MEMCTRL_TPDATA		0x4c
#define	MEMCTRL_BARRIER		0x50
#define	MEMCTRL_CORE		0x54

/* Control register bit definitions */
#define	MEMCTRL_CONTROL_MRSCMD	0x00000010
#define	MEMCTRL_CONTROL_PRECMD	0x00000008
#define	MEMCTRL_CONTROL_REFCMD	0x00000004
#define	MEMCTRL_CONTROL_SEQEN	0x00000002
#define	MEMCTRL_CONTROL_ACCEN	0x00000001

/* BCM5836 Address map */
#define BCM5836_SDRAM		0x00000000 /* 0-128MB Physical SDRAM */
#define BCM5836_PCI_MEM		0x08000000 /* Host Mode PCI mem space (64MB)*/
#define BCM5836_PCI_CFG		0x0c000000 /* Host Mode PCI cfg space (64MB)*/
#define BCM5836_PCI_DMA		0x40000000 /* Client Mode PCI mem space (1GB)*/
#define	BCM5836_SDRAM_SWAPPED	0x10000000 /* Byteswapped Physical SDRAM */
#define BCM5836_ENUM		0x18000000 /* Beginning of core enum space */
